<template>
  <div>
    <div v-if="!form">
      LOADING
    </div>
    <div v-if="form[regName]">
      <div class="form-group" v-for="items of form[regName]" :key="items.id">
        <div class="form-group text-left">
          <label>{{items.title}}</label>

          <div v-if="items.photo.has">
            <img :src="env.host + '/14/api/upload/' +items.photo.id" class="w-50 m-2 p-2 text-center">
          </div>
          <div v-if="items.formtype == 'RADIO'">
            <ul class="radio" :class="items.field">
              <li v-for="(values, count) in items.options" :key="values.id" v-on:click="radioClick(values, items.field, count)" :class="[items.field + '-' + count, {'active' : count == 0}]">
                {{ values }}
              </li>
            </ul>
          </div>
          <div v-if="items.formtype == 'INPUT'">
            <div v-if="items.class == 'TEXTBOX'">
              <textarea v-model="submit[items.field] = items.value" :name="items.field" :placeholder="items.placeholder" v-validate=" { regex: new RegExp(items.regex)}, 'required|min:5'">
              </textarea>
            </div>
            <div v-else>
              <div v-if="items.class == 'TEL'">
                <input v-model=" submit[items.field]=items.value" :name="items.field" :placeholder="items.placeholder" v-validate="'required|numeric|max:11|min:9|regex:^[0]{1}[0-9]{9}$'" maxlength="10">
              </div>
              <div v-else>
                <input v-model="submit[items.field] = items.value" :name="items.field" :placeholder="items.placeholder" v-validate=" { regex:new RegExp(items.regex)}, 'required'">
              </div>
            </div>
          </div>
          <div v-if="items.value==''">
            <div v-if=" items.formtype=='SELECT'">
              <select v-model="submit[items.field]" :name="items.field" v-validate="'required'">
                <option v-for="(values) in items.options" :key="values.id">
                  {{values}}
                </option>
              </select>
            </div>
          </div>
          <div v-else>
            <div v-if=" items.formtype=='SELECT'">
              <select v-model="submit[items.field]=items.value" :name="items.field">
                <option v-for="(values) in items.options" :key="values.id">
                  {{values}}
                </option>
              </select>
            </div>
          </div>
          <div v-if="items.formtype=='DATE'">
            <input type="date" class="form-date" v-model="submit[items.field]=items.value" :name="items.field" :placeholder="items.placeholder" v-validate="'required|date_format:YYYY-MM-DD'">
          </div>
          <div v-if="items.formtype=='UPLOAD'">
            <div class="image-preview pt-4 pb-4 pl-2 pr-2" v-if="imageData.length > 0">
              <img class="preview w-100" :src="imageData">
            </div>
            <input type="file" :name="items.field" :class="items.field" accept="image/*, application/pdf" @change="onFileChange" v-if="imageData.length > 0">
            <input type="file" :name="items.field" :class="items.field" v-validate=" 'required|size:5000'" accept="image/*, application/pdf" @change="onFileChange" v-else>
          </div>
          <span v-show="errors.has(items.field)" class="color-red text-alert">{{ errors.first(items.field) }}</span>
        </div>
      </div>
      <div class="form-footer">
        <div class="row">
          <div class="col text-right prev">
            <router-link :to="{ name: 'Index'}">
              <div class="textbox row step1" v-if="$route.name=='Reg_Auth'">
                <div class="col-2 text-main ml-2">
                  <i class="fas fa-angle-left"></i>
                </div>
                <div class="col text-sub text-left">
                  <span>หน้าก่อน</span><br>
                  <b class="d-none d-md-block">หน้าหลัก</b>
                </div>
              </div>
            </router-link>
            <!-- <router-link :to="{ name: 'Index'}"> -->
            <div class="textbox row step1" v-if="$route.name=='Reg_Personal'">
              <div class="col-2 text-main ml-2">
                <i class="fas fa-angle-left"></i>
              </div>
              <div class="col text-sub text-left" v-on:click="sendSaveForm({page: 1, camp: 'GLOBAL', to: 'Index'})">
                <span>หน้าก่อน</span><br>
                <b class="d-none d-md-block">หน้าหลัก</b>
              </div>
            </div>
            <!-- </router-link> -->
            <!-- <router-link :to="{ name: 'Reg_Personal'}"> -->
            <div class="textbox row step2" v-if="$route.name=='Reg_Camp'">
              <div class="col-2 text-main ml-2">
                <i class="fas fa-angle-left"></i>
              </div>
              <div class="col text-sub text-left" v-on:click="sendSaveForm({page: 2, camp: 'GLOBAL', to: 'Reg_Personal'})">
                <span>หน้าก่อน</span><br>
                <b class="d-none d-md-block">ข้อมูลส่วนตัว</b>
              </div>
            </div>
            <!-- </router-link> -->
            <!-- <router-link :to="{ name: 'Reg_Camp'}"> -->
            <div class="textbox row step3" v-if="$route.path.split( '/').indexOf('subcamp')> 0">
              <div class="col-2 text-main ml-2">
                <i class="fas fa-angle-left"></i>
              </div>
              <div class="col text-sub text-left" v-on:click="sendSaveForm({page: 3, camp: campName, to: 'Reg_Camp', submit: true})">
                <span>หน้าก่อน1</span><br>
                <b class="d-none d-md-block">คำถามค่าย</b>
              </div>
            </div>
            <!-- </router-link> -->
          </div>
          <div class="col text-right next">
            <div class="textbox row step1" v-if="$route.name == 'Reg_Personal'">
              <div class="col text-sub" v-on:click="sendSaveForm({page: 1, camp: 'GLOBAL', to: 'Reg_Camp'})">
                <span>หน้าต่อไป</span><br>
                <b class="d-none d-md-block">คำถามค่าย</b>
              </div>
              <div class="col-2 text-main">
                <i class="fas fa-angle-right"></i>
              </div>
            </div>
            <div class="textbox row step2" v-if="$route.name == 'Reg_Camp'">
              <div class="col text-sub" v-on:click="sendSaveForm({page: 2, camp: 'GLOBAL', to: forcePage })">
                <span>หน้าต่อไป</span><br>
                <b class="d-none d-md-block">คำถามแคมป์ย่อย</b>
              </div>
              <div class="col-2 text-main">
                <i class="fas fa-angle-right"></i>
              </div>
            </div>
            <div class="textbox row step1" v-if="$route.path.split('/').indexOf('subcamp') > 0">
              <div class="col text-sub" v-on:click="sendSaveForm({page: 3, camp: campName, to: 'Reg_Summary'})">
                <span>ส่งฟอร์ม</span><br>
                <b class="d-none d-md-block">SUBMIT</b>
              </div>
              <div class="col-2 text-main">
                <i class="fas fa-angle-right"></i>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters, mapMutations, mapActions } from 'vuex';
import { Validator } from 'vee-validate';

import router from '../../../router';
const messages = {
  en: {
    messages: {
      regex: () => 'รูปแบบข้อความไม่ถูกต้อง',
      required: () => 'ต้องการข้อมูล',
      numeric: () => 'จำเป็นต้องเป็นตัวเลขเท่านั้น',
      size: (name, val) => 'ขนาดรูปต้องไม่เกิน ' + val + ' KB',
      min: (name, val) => 'ตัวอักษรต้องไม่น้อยกว่า ' + val + ' ตัวอักษร',
      max: (name, val) => 'ตัวอักษรต้องมากกว่า ' + val + ' ตัวอักษร',
      date_between: (name, val) => 'ปีไม่ถูกต้อง'
    }
  }
};
Validator.localize(messages);
export default {
  name: 'Reg-Form',
  beforeRouteUpdate(to, from, next) {
    this.submitFinish();
  },
  data() {
    return {
      imageData: '',
      submit: {},
      regName: location.pathname.split('/')[location.pathname.split('/').length - 1],
      campName: location.pathname.split('/')[location.pathname.split('/').length - 1]
    };
  },
  async created() {
    await this.activeUserProgress();
    let pathname = location.pathname.split('/')[location.pathname.split('/').length - 1];
    var pagenum;
    switch (pathname) {
      case 'personal':
        pagenum = 1;
        break;
      case 'camp':
        pagenum = 2;
        break;
    }
    if (location.pathname.split('/').indexOf('subcamp') > 0) {
      pagenum = 3;
    }
    if (pagenum >= 3) {
      await this.requestForm({ page: pagenum, camp: pathname.toUpperCase() });
      this.regName = location.pathname.split('/')[location.pathname.split('/').length - 2];
    } else {
      await this.requestForm({ page: pagenum, camp: 'GLOBAL' });
      var _this = this;
      setTimeout(function() {
        _this.autoPick();
      }, 1000);
    }
  },
  updated() {
    this.saveData(this.submit, 1);
    this.updateValidator(this.$validator);
  },
  computed: {
    ...mapState(['user', 'env', 'validator', 'forcePage']),
    ...mapGetters({ form: 'getFormData' })
  },

  methods: {
    ...mapActions(['requestForm', 'saveForm', 'activeUserProgress']),
    ...mapMutations(['saveData', 'updateValidator', 'formNum']),
    ...mapGetters(['getUserProgress, getForcePage']),
    scrollTo: scrollTo,
    submitFinish() {
      if (this.getUserProgress().submit) {
        router.push({
          name: 'Reg_Summary'
        });
      }
    },
    sendSaveForm(page) {
      this.$validator.validateAll().then((result) => {
        if (result) {
          this.saveForm(page);
        }
      });
    },
    radioClick(data, name, count) {
      var childrenSize = $('ul.' + name).children().length;
      this.submit[name] = data;
      for (let i = 0; i < childrenSize; i++) {
        $('.' + name + '-' + i).removeClass('active');
      }
      $('.' + name + '-' + count).addClass('active');
    },
    autoPick() {
      if (location.pathname.split('/').indexOf('subcamp') != 3) {
        for (let i = 0; i < this.form[this.regName].length; i++) {
          var items = this.form[this.regName][i];
          if (['RADIO'].indexOf(items.formtype) > -1) {
            if (items.value == '') {
              this.submit[items.field] = items.options[0];
            } else {
              this.submit[items.field] = items.value;
            }
            //SELECT RADIO
            if (items.formtype == 'RADIO') {
              for (let i in items.options) {
                if (items.value == items.options[i]) {
                  this.radioClick(items.options[i], items.field, i);
                }
              }
            }
          }
          // IMAGE
          var _this = this;
          if (items.formtype == 'UPLOAD' && items.value != '') {
            var img = '/14/api/upload/' + items.value;
            _this.imageData = img;
            _this.loadXHR(img).then(function(blob) {
              _this.submit[items.field] = blob;
            });
          }
        }
      }
    },
    getDataUri(url, callback) {
      var image = new Image();

      image.onload = function() {
        var canvas = document.createElement('canvas');
        canvas.width = this.naturalWidth; // or 'width' if you want a special/scaled size
        canvas.height = this.naturalHeight; // or 'height' if you want a special/scaled size

        canvas.getContext('2d').drawImage(this, 0, 0);

        // Get raw image data
        callback(canvas.toDataURL('image/png').replace(/^data:image\/(png|jpg);base64,/, ''));

        // ... or get as Data URI
        callback(canvas.toDataURL('image/png'));
      };

      image.src = url;
    },
    loadXHR(url) {
      return new Promise(function(resolve, reject) {
        try {
          var xhr = new XMLHttpRequest();
          xhr.open('GET', url);
          xhr.responseType = 'blob';
          xhr.onerror = function() {
            reject('Network error.');
          };
          xhr.onload = function() {
            if (xhr.status === 200) {
              resolve(xhr.response);
            } else {
              reject('Loading error:' + xhr.statusText);
            }
          };
          xhr.send();
        } catch (err) {
          reject(err.message);
        }
      });
    },
    onFileChange(e) {
      var files = e.target.files || e.dataTransfer.files;
      var name = e.srcElement.className;
      if (!files.length) return;
      this.submit[name] = files[0];
      this.createImage(e);
    },
    createImage(event) {
      var input = event.target;
      if (input.files && input.files[0]) {
        var reader = new FileReader();
        reader.onload = (e) => {
          this.imageData = e.target.result;
        };
        reader.readAsDataURL(input.files[0]);
      }
    }
  }
};
</script>

<style>

</style>
